regina::Dim2GluingPerms Class Reference
Census of Triangulations

Represents a specific set of gluing permutations to complement a particular pairwise matching of triangle edges. More...

`#include <census/dim2gluingperms.h>`

Inheritance diagram for regina::Dim2GluingPerms:

## Public Types

typedef DimTraits< dim >::FacetPairing | FacetPairing
typedef DimTraits< dim >::Perm | Perm
typedef DimTraits< dim >::Simplex | Simplex
typedef DimTraits< dim >::Triangulation | Triangulation

## Public Member Functions

| Dim2GluingPerms (const Dim2GluingPerms &cloneMe)
| Creates a new set of gluing permutations that is a clone of the given permutation set. More...
| Dim2GluingPerms (std::istream &in)
| Reads a new set of gluing permutations from the given input stream. More...
bool | inputError () const
| Was an error found during construction from an input stream? More...
unsigned | size () const
| Returns the total number of simplices under consideration. More...
const FacetPairing * | getFacetPairing () const
| Returns the specific pairing of simplex facets that this set of gluing permutations complements. More...
Perm | gluingPerm (const NFacetSpec< dim > &source) const
| Returns the gluing permutation associated with the given simplex facet. More...
Perm | gluingPerm (unsigned simp, unsigned facet) const
| Returns the gluing permutation associated with the given simplex facet. More...
Triangulation * | triangulate () const
| Returns a newly created triangulation as modelled by this set of gluing permutations and the associated simplex facet pairing. More...
virtual void | dumpData (std::ostream &out) const
| Dumps all internal data in a plain text format to the given output stream. More...

## Protected Member Functions

| Dim2GluingPerms (const Dim2EdgePairing *pairing)
| Creates a new permutation set. More...
int & | permIndex (const NFacetSpec< dim > &source)
| Returns the index into array Perm::Sn_1 describing how the the given facet is joined to its partner. More...
int & | permIndex (unsigned simp, unsigned facet)
| Returns the index into array Perm::Sn_1 describing how the the given facet is joined to its partner. More...
const int & | permIndex (const NFacetSpec< dim > &source) const
| Returns the index into array Perm::Sn_1 describing how the the given facet is joined to its partner. More...
const int & | permIndex (unsigned simp, unsigned facet) const
| Returns the index into array Perm::Sn_1 describing how the the given facet is joined to its partner. More...
int | gluingToIndex (const NFacetSpec< dim > &source, const Perm &gluing) const
| Returns the index into array Perm::Sn_1 corresponding to the given gluing permutation from the given facet to its partner. More...
int | gluingToIndex (unsigned simp, unsigned facet, const Perm &gluing) const
| Returns the index into array Perm::Sn_1 corresponding to the given gluing permutation from the given facet to its partner. More...
Perm | indexToGluing (const NFacetSpec< dim > &source, int index) const
| Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm::Sn_1. More...
Perm | indexToGluing (unsigned simp, unsigned facet, int index) const
| Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm::Sn_1. More...

## Protected Attributes

const FacetPairing * | pairing_
| The facet pairing that this permutation set complements. More...
int * | permIndices_
| The index into array Perm::Sn_1 describing how each simplex facet is glued to its partner. More...
bool | inputError_
| Has an error occurred during construction from an input stream? More...

## Detailed Description

Represents a specific set of gluing permutations to complement a particular pairwise matching of triangle edges.

Given a pairwise matching of edges (as described by class Dim2EdgePairing), each edge that is matched with some other edge will have an associated permutation of three elements (as described by class NPerm3).

If an edge is matched with some other edge, the two associated permutations in this set will be inverses. If an edge is left deliberately unmatched, it will have no associated permutation in this set.

Such a set of permutations models part of the structure of a 2-manifold triangulation, in which each triangle edge that is glued to another edge has a corresponding gluing permutation (and the matched edge has the inverse gluing permutation).

Python:
  Not present.

## Constructor & Destructor Documentation

regina::Dim2GluingPerms::Dim2GluingPerms | ( | const Dim2GluingPerms & | cloneMe | ) |

inline

Creates a new set of gluing permutations that is a clone of the given permutation set.

Parameters

  cloneMe | the gluing permutations to clone.

regina::Dim2GluingPerms::Dim2GluingPerms | ( | std::istream & | in | ) |

inline

Reads a new set of gluing permutations from the given input stream.

This routine reads data in the format written by dumpData().

If the data found in the input stream is invalid or incorrectly formatted, the routine inputError() will return `true` but the contents of this object will be otherwise undefined.

Warning
  The data format is liable to change between Regina releases. Data in this format should be used on a short-term temporary basis only.

Parameters

  in | the input stream from which to read.

regina::Dim2GluingPerms::Dim2GluingPerms | ( | const Dim2EdgePairing * | pairing | ) |

inline protected

Creates a new permutation set.

All internal arrays will be allocated but not initialised.

Precondition
  The given edge pairing is connected, i.e., it is possible to reach any triangle from any other triangle via a series of matched edge pairs.
  The given edge pairing is in canonical form as described by Dim2EdgePairing::isCanonical(). Note that all edge pairings constructed by Dim2EdgePairing::findAllPairings() are of this form.

Parameters

  pairing | the specific pairing of triangle edges that this permutation set will complement.

## Member Function Documentation

virtual void regina::NGenericGluingPerms< dim >::dumpData | ( | std::ostream & | out | ) | const

virtual inherited

Dumps all internal data in a plain text format to the given output stream.

This object can be recreated from this text data by calling the input stream constructor for this class.

This routine may be useful for transferring objects from one processor to another.

Note that subclass data is written after superclass data, so it is safe to dump data from a subclass and then recreate a new superclass object from that data (though subclass-specific information will of course be lost).

Warning
  The data format is liable to change between Regina releases. Data in this format should be used on a short-term temporary basis only.

Parameters

  out | the output stream to which the data should be written.

Reimplemented in regina::Dim2GluingPermSearcher.

const FacetPairing* regina::NGenericGluingPerms< dim >::getFacetPairing | ( |  | ) | const

inherited

Returns the specific pairing of simplex facets that this set of gluing permutations complements.

Returns
  the corresponding simplex facet pairing.

Perm regina::NGenericGluingPerms< dim >::gluingPerm | ( | const NFacetSpec< dim > & | source | ) | const

inherited

Returns the gluing permutation associated with the given simplex facet.

Precondition
  The given facet is actually paired with some other facet in the underlying pairwise matching (see routine getFacetPairing()).
  The given facet is a real simplex facet (not boundary, before-the-start or past-the-end).

Parameters

  source | the simplex facet under investigation.

Returns
  the associated gluing permutation.

Perm regina::NGenericGluingPerms< dim >::gluingPerm | ( | unsigned | simp,
|  | unsigned | facet
| ) |  | const

inherited

Returns the gluing permutation associated with the given simplex facet.

Precondition
  The given facet is actually paired with some other facet in the underlying pairwise matching (see routine getFacetPairing()).

Parameters

  simp | the simplex under investigation (this must be strictly less than the total number of simplices under consideration).
  facet | the facet of the given simplex under investigation (between 0 and dim inclusive).

Returns
  the associated gluing permutation.

int regina::NGenericGluingPerms< dim >::gluingToIndex | ( | const NFacetSpec< dim > & | source,
|  | const Perm & | gluing
| ) |  | const

protected inherited

Returns the index into array Perm::Sn_1 corresponding to the given gluing permutation from the given facet to its partner.

This need not be the index into Perm::Sn_1 that is currently stored for the given facet.

Indices into array Perm::Sn_1 are stored internally in the array permIndices_. Full gluing permutations on the other hand are used in constructing triangulations.

Precondition
  The given simplex facet has a partner according to the underlying facet pairing, i.e., is not a boundary facet.
  If the given simplex facet and its partner are facets x and y of their respective simplices, then the given gluing permutation maps x to y.

Parameters

  source | the simplex facet under investigation.
  gluing | a possible gluing permutation from the given simplex facet to its partner according to the underlying facet pairing.

Returns
  the index into Perm::Sn_1 corresponding to the given gluing permutation; this will be between 0 and dim!-1 inclusive.

int regina::NGenericGluingPerms< dim >::gluingToIndex | ( | unsigned | simp,
|  | unsigned | facet,
|  | const Perm & | gluing
| ) |  | const

protected inherited

Returns the index into array Perm::Sn_1 corresponding to the given gluing permutation from the given facet to its partner.

This need not be the index into Perm::Sn_1 that is currently stored for the given facet.

Indices into array Perm::Sn_1 are stored internally in the array permIndices_. Full gluing permutations on the other hand are used in constructing triangulations.

Precondition
  The given simplex facet has a partner according to the underlying facet pairing, i.e., is not a boundary facet.
  If the given simplex facet and its partner are facets x and y of their respective simplices, then the given gluing permutation maps x to y.

Parameters

  simp | the simplex under investigation; this must be strictly less than the total number of simplices under consideration.
  facet | the facet of the given simplex under investigation; this must be between 0 and dim inclusive.
  gluing | a possible gluing permutation from the given simplex facet to its partner according to the underlying facet pairing.

Returns
  the index into Perm::Sn_1 corresponding to the given gluing permutation; this will be between 0 and dim!-1 inclusive.

Perm regina::NGenericGluingPerms< dim >::indexToGluing | ( | const NFacetSpec< dim > & | source,
|  | int | index
| ) |  | const

protected inherited

Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm::Sn_1.

This index into Perm::Sn_1 need not be the index that is currently stored for the given facet.

Indices into array Perm::Sn_1 are stored internally in the array permIndices_. Full gluing permutations on the other hand are used in constructing triangulations.

If the given simplex facet and its partner according to the underlying facet pairing are facets x and y of their respective simplices, then the resulting gluing permutation will map x to y.

Precondition
  The given simplex facet has a partner according to the underlying facet pairing, i.e., is not a boundary facet.

Parameters

  source | the simplex facet under investigation.
  index | an index into Perm::Sn_1; this must be between 0 and dim!-1 inclusive.

Returns
  the gluing permutation corresponding to the given index into Perm::Sn_1.

Perm regina::NGenericGluingPerms< dim >::indexToGluing | ( | unsigned | simp,
|  | unsigned | facet,
|  | int | index
| ) |  | const

protected inherited

Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm::Sn_1.

This index into Perm::Sn_1 need not be the index that is currently stored for the given facet.

Indices into array Perm::Sn_1 are stored internally in the array permIndices_. Full gluing permutations on the other hand are used in constructing triangulations.

If the given simplex facet and its partner according to the underlying facet pairing are facets x and y of their respective simplices, then the resulting gluing permutation will map x to y.

Precondition
  The given simplex facet has a partner according to the underlying facet pairing, i.e., is not a boundary facet.

Parameters

  simp | the simplex under investigation; this must be strictly less than the total number of simplices under consideration.
  facet | the facet of the given simplex under investigation; this must be between 0 and dim inclusive.
  index | an index into Perm::Sn_1; this must be between 0 and dim!-1 inclusive.

Returns
  the gluing permutation corresponding to the given index into Perm::Sn_1.

bool regina::NGenericGluingPerms< dim >::inputError | ( |  | ) | const

inherited

Was an error found during construction from an input stream?

This routine returns `true` if an input stream constructor was used to create this object but the data in the input stream was invalid or incorrectly formatted.

If a different constructor was called (i.e., no input stream was used), then this routine will always return `false`.

Returns
  `true` if an error occurred during construction from an input stream, or `false` otherwise.

int& regina::NGenericGluingPerms< dim >::permIndex | ( | const NFacetSpec< dim > & | source | ) |

protected inherited

Returns the index into array Perm::Sn_1 describing how the the given facet is joined to its partner.

Note that this permutation is not a gluing permutation as such, but rather a permutation of 0,...,dim-1 only. For a real facet gluing permutation, see routine gluingPerm().

Precondition
  The given facet is a real simplex facet (not boundary, before-the-start or past-the-end).

Parameters

  source | the simplex facet under investigation.

Returns
  a reference to the corresponding array index.

int& regina::NGenericGluingPerms< dim >::permIndex | ( | unsigned | simp,
|  | unsigned | facet
| ) |  |

protected inherited

Returns the index into array Perm::Sn_1 describing how the the given facet is joined to its partner.

Note that this permutation is not a gluing permutation as such, but rather a permutation of 0,...,dim-1 only. For a real facet gluing permutation, see routine gluingPerm().

Parameters

  simp | the simplex under investigation (this must be strictly less than the total number of simplices under consideration).
  facet | the facet of the given simplex under investigation (between 0 and dim inclusive).

Returns
  a reference to the corresponding array index.

const int& regina::NGenericGluingPerms< dim >::permIndex | ( | const NFacetSpec< dim > & | source | ) | const

protected inherited

Returns the index into array Perm::Sn_1 describing how the the given facet is joined to its partner.

Note that this permutation is not a gluing permutation as such, but rather a permutation of 0,...,dim-1 only. For a real facet gluing permutation, see routine gluingPerm().

Precondition
  The given facet is a real simplex facet (not boundary, before-the-start or past-the-end).

Parameters

  source | the simplex facet under investigation.

Returns
  a reference to the corresponding array index.

const int& regina::NGenericGluingPerms< dim >::permIndex | ( | unsigned | simp,
|  | unsigned | facet
| ) |  | const

protected inherited

Returns the index into array Perm::Sn_1 describing how the the given facet is joined to its partner.

Note that this permutation is not a gluing permutation as such, but rather a permutation of 0,...,dim-1 only. For a real facet gluing permutation, see routine gluingPerm().

Parameters

  simp | the simplex under investigation (this must be strictly less than the total number of simplices under consideration).
  facet | the facet of the given simplex under investigation (between 0 and dim inclusive).

Returns
  a reference to the corresponding array index.

unsigned regina::NGenericGluingPerms< dim >::size | ( |  | ) | const

inherited

Returns the total number of simplices under consideration.

Returns
  the number of simplices under consideration.

Triangulation* regina::NGenericGluingPerms< dim >::triangulate | ( |  | ) | const

inherited

Returns a newly created triangulation as modelled by this set of gluing permutations and the associated simplex facet pairing.

Each matched pair of facets and their associated permutations will be realised as two simplex facets in the triangulation glued together with the corresponding gluing permutation. Each unmatched facet will be realised as a boundary facet in the triangulation.

It is the responsibility of the caller of this routine to delete this triangulation once it is no longer required.

Returns
  a newly created triangulation modelled by this structure.

## Member Data Documentation

bool regina::NGenericGluingPerms< dim >::inputError_

protected inherited

Has an error occurred during construction from an input stream?

const FacetPairing* regina::NGenericGluingPerms< dim >::pairing_

protected inherited

The facet pairing that this permutation set complements.

This is guaranteed to be the minimal representative of its facet pairing isomorphism class.

int* regina::NGenericGluingPerms< dim >::permIndices_

protected inherited

The index into array Perm::Sn_1 describing how each simplex facet is glued to its partner.

Note that this is not a gluing permutation as such but rather a permutation of 0,...,dim-1 only (see the routines gluingToIndex() and indexToGluing() for conversions). If a permutation has not yet been selected (e.g., if this permutation set is still under construction) then this index is -1.

The documentation for this class was generated from the following file:

- census/dim2gluingperms.h

Copyright © 1999-2014, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).